/**
 * This file can access the DOM elements and also trigger DOM events
 */
var loggedIn = false;
var floatingBar = null;
var startingOverlay = null;
var finalizingOverlay = null;
var overlayInterval = null;
const origin = "https://begenieus.com"
var userDetails = {};
var btn = {};
var tutorShotOid = null;
var containerDiv;
var sr;
var webpageObserver = { disconnect() { } }
!(async function () {

    if (window.origin == origin) { login() }
    else {
        window.clearInterval(window.tutorShotInterval)

        window.tutorShotInterval = setInterval(async () => {
            try {
                let data = await getCaptureData()
                reRenderFloatingBar(data)
            } catch (err) {
                console.log(err)
            }
        }, 1000)
    }

    containerDiv = document.createElement('div')
    containerDiv.setAttribute('test', 'tutor-shot')
    containerDiv.style.position = "fixed"
    containerDiv.style.display = "block"
    containerDiv.style.background = "transparent"
    containerDiv.style.width = "0px"
    containerDiv.style.height = "0px"
    containerDiv.style.zIndex = "9999"


    sr = containerDiv.attachShadow({ mode: 'open' });

    let styleTag = document.createElement('style')
    styleTag.setAttribute('tutor-shot-style', '')
    styleString = /*css*/`
    .tutor-shot-overlay{
        all: unset;
        position: fixed;
        top: 0px;
        bottom: 0px;
        left: 0px;
        right: 0px;
        background-color: #000000a0;
        pointer-events: inherit;
        z-index: 101;
        display: flex;
        color: white;
        justify-content: center;
        align-items: center;
        font-size: 28px;
    }
    .tutor-shot {
        all: unset;
        position: fixed;
        bottom: 30px;
        /* width: 50px; */
        height: 50px;
        z-index: 100;
        background: #fff;
        padding: 10px;
        border-radius: 50px;
        box-shadow: 0px 0px 20px #cccccc;
        display: flex;
        align-items: center;
        font-family: Arial, Helvetica, sans-serif;
        transition: 0.3s;
        pointer-events: auto;
    }

    .tutor-shot.tutor-shot-right {
        right: 30px;
        transition: 0.5s;
    }
    .tutor-shot.tutor-shot-left {
        left: 30px;
        transition: 0.5s;
    }

    .tutor-shot.tutor-shot-left {
        left: 30px;
        transition: 0.5s;
    }

    .tutor-shot .counter-count {
        all: unset;
        min-width: 16px;
        border-radius: 50px;
        background-color: rgb(3, 153, 28);
        color: #fff;
        display: flex;
        align-items: center;
        justify-content: center;
        font-size: 13px;
        font-weight: 600;
        position: absolute;
        right: 0px;
        top: -7px;
        z-index: 2;
        padding: 4px;
    }

    .tutor-shot .logo {
        all: unset;
    }

    .tutor-shot .logo .logo-img {
        display: block;
        all: unset;
        margin-top: -4px;
        margin-left: -1px;
        height: 50px;
    }

    .tutor-shot .content {
        all: unset;
        display: flex;
        align-items: center;
        overflow: hidden;
        margin-left: 5px;
        margin-right: 5px;
    }

    .tutor-shot .content .item {
        all: unset;
        display: flex;
        align-items: center;
        margin-right: 16px;
        transition: 0.3s;
        cursor: pointer;
    }

    .tutor-shot .content .item .img {
        all: unset;
        margin-right: 3px;
        filter: hue-rotate(335deg) brightness(0%) contrast(68%);
        width: 20px;
    }

    .tutor-shot .content .item .item-text {
        all: unset;
        padding-top: 2px;
    }
    .tutor-shot .content .item.width-100 {
        width: 100%;
        background: red;
    }

    `
    styleTag.append(styleString)
    sr.append(styleTag)

    floatingBar = document.createElement('div')
    floatingBar.setAttribute('class', `tutor-shot tutor-shot-right`)
    let innerHTML = /*html*/`

<div class="counter-count" tutor-shot="counter" style="display:none;"></div>
<div class="logo">
    <img tutor-shot="main-logo" class="logo-img" src="${origin}/assets/images/tutor-shot-48.png" width="40">
</div>
<div class="content">
    <div class="item" tutor-shot="play-btn">
        <img class="img" src="${origin}/assets/icons/play.svg" width="20">
        <span class="item-text" tutor-shot="play-text">RESUME</span>
    </div>
    <div class="item" tutor-shot="pause-btn">
        <img class="img" src="${origin}/assets/icons/pause.svg" width="20">
        <span class="item-text">PAUSE</span>
    </div>
    <div class="item" tutor-shot="stop-btn">
        <img class="img" src="${origin}/assets/icons/stop-circle.svg" width="20">
        <span class="item-text">STOP</span>
    </div>
    <div class="item" tutor-shot="restart-btn">
        <img class="img" src="${origin}/assets/icons/redo.svg" width="20">
        <span class="item-text">RESTART</span>
    </div>
    <div class="item" tutor-shot="capture-btn" style="display:none;">
        <img class="img" src="${origin}/assets/icons/capture.svg" width="20">
        <span class="item-text">CAPTURE</span>
    </div>
    <div class="item" tutor-shot="switch-btn">
        <img class="img" src="${origin}/assets/icons/left-arrow-to-left.svg" width="20">
    </div>
</div>

    `
    floatingBar.innerHTML = innerHTML
    floatingBar.style.pointerEvents = 'auto'
    sr.append(floatingBar)

    floatingBar.addEventListener('mouseenter', (e) => {
        floatingBar.style.width = ''
    })
    floatingBar.addEventListener('mouseleave', (e) => {
        floatingBar.style.width = '50px'
    })


    document.addEventListener("visibilitychange", async function () {
        if (document.visibilityState === 'visible') {
            if (window.origin == origin) login()
            let data = await getCaptureData()
            reRenderFloatingBar(data)
        }
    })
    let data = await getCaptureData()
    reRenderFloatingBar(data)

})()
async function login() {

    let userDetails = {
        uid: localStorage.getItem('userId'),
        name: localStorage.getItem('name'),
        email: localStorage.getItem('email'),
        userOid:localStorage.getItem('userOid')
    }
    if (userDetails?.uid || userDetails?.email) { // can login
        chrome.runtime.sendMessage({ action: "login", userDetails })
    }
}

async function getCaptureData() {
    let statusData = await chrome.runtime.sendMessage({ action: "checkStatus" })
    userDetails = statusData.userDetails
    tutorShotOid = statusData.tutorShotOid
    return statusData
}

function reRenderFloatingBar(data) {
    if (data) {
        if (data.status == 'stopped') {
            containerDiv.remove()
            return
        }
        else if (!document.body.contains(floatingBar)) {
            document.body.append(containerDiv)
        }
    }
    if (!btn.play) {
        btn.play = sr.querySelector('[tutor-shot="play-btn"]')
        btn.play.addEventListener('click', resumeRecording)
    }
    if (!btn.mainLogo) {
        btn.mainLogo = sr.querySelector('[tutor-shot="main-logo"]')
    }
    if (!btn.capture) {
        btn.capture = sr.querySelector('[tutor-shot="capture-btn"]')
    }
    if (!btn.playText) btn.playText = sr.querySelector('[tutor-shot="play-text"]')
    if (!btn.pause) {
        btn.pause = sr.querySelector('[tutor-shot="pause-btn"]')
        btn.pause.addEventListener('click', pauseRecording)
    }
    if (!btn.stop) {
        btn.stop = sr.querySelector('[tutor-shot="stop-btn"]')
        btn.stop.addEventListener('click', stopRecording)
    }
    if (!btn.restart) {
        btn.restart = sr.querySelector('[tutor-shot="restart-btn"]')
        btn.restart.addEventListener('click', restartRecording)
    }
    if (!btn.switch) {
        btn.switch = sr.querySelector('[tutor-shot="switch-btn"]')
        btn.switch.addEventListener('click', changeBarPosition)
    }
    if (!btn.counter) btn.counter = sr.querySelector('[tutor-shot="counter"]')

    if (data?.hasOwnProperty('imageNumber')) {
        btn.counter.innerHTML = `${data.imageNumber}`
        if (data.imageNumber <= 0) btn.counter.style.display = 'none'
        else btn.counter.style.display = 'flex'
    }
    if (data?.state == 'paused') {
        btn.play.style.display = 'flex'
        btn.pause.style.display = 'none'
        btn.stop.style.display = 'flex'
        btn.restart.style.display = 'flex'
        btn.mainLogo.style.display = 'block'
    }
    else if (data?.status == 'recording') {
        btn.play.style.display = 'none'
        btn.pause.style.display = 'flex'
        btn.restart.style.display = 'flex'
        btn.stop.style.display = 'flex'
        btn.mainLogo.style.display = 'block'
        // btn.capture.style.display = 'flex'
    }
    else { // stopped
        btn.play.style.display = 'flex'
        btn.pause.style.display = 'none'
        btn.stop.style.display = 'none'
        btn.restart.style.display = 'none'
        btn.mainLogo.style.display = 'block'
    }
}

var recording = false;
const api = axios.create({
    baseURL: `${origin}/api`,
    headers: {
        'Access-Control-Allow-Origin': '*', // Replace '*' with the origin you need
        'Content-Type': 'application/json',
    },
});

window.addEventListener('mousedown', async function (e) {

    // to prevent the event when clicking inside the floating bar
    if (containerDiv?.contains(e.target) || startingOverlay?.contains(e.target)) {
        return
    }
    if (e.button === 0) { // only left click allowed

        let captureInfo = {
            targetDimensions: e.target.getBoundingClientRect(), // this is for the backdrop
            dimensions: { // this is for the main image
                height: document.body.clientHeight,
                width: document.body.clientWidth,
            },
            tagName: e.target.tagName,
            text: e.target.innerText.substr(0,100),
            url: location.href,
            origin: location.origin,
        }
        let newLineBreakIndex = captureInfo.text.search('\n')
        if (newLineBreakIndex != -1) captureInfo.text = captureInfo.text.slice(0, newLineBreakIndex)
        chrome.runtime.sendMessage({ action: "captureSS", captureInfo })
        let data = await getCaptureData()
        reRenderFloatingBar(data)
    }

})
// content.js
chrome.runtime.onMessage.addListener(async function (message, sender, sendResponse) {
    if (message.action == 'tabChanged') {
        // console.log('tabChanged', message)
    }
    if (message.action == 'loggedOut') {
        reRenderFloatingBar(data)
    }
    let data = await getCaptureData()
    reRenderFloatingBar(data)
    if (message.message == 'recordingStarted') {
        if (floatingBar) {
            if (!startingOverlay) {
                clearInterval(overlayInterval)
                let counter = 5
                startingOverlay = document.createElement('div')
                startingOverlay.setAttribute('class', 'tutor-shot-overlay')
                sr.append(startingOverlay)
                function changeText() {
                    if (counter <= 0) {
                        clearInterval(overlayInterval)
                        startingOverlay.remove()
                        startingOverlay = null
                        return
                    }
                    startingOverlay.innerHTML = `
                    <div>
                        Click on the webpage to take screenshot
                        <br>
                        Capture would start in ${counter--} seconds
                    </div>
                    `
                }
                changeText()
                overlayInterval = setInterval(changeText, 1000)

            }
        }

    }
    else if (message.message == 'showRestartProcess') {
        finalizingOverlay = document.createElement('div')
        finalizingOverlay.setAttribute('class', 'tutor-shot-overlay')
        finalizingOverlay.setAttribute('style', `all: unset; position: fixed; top: 0px; bottom: 0px; left: 0px; right: 0px; background-color: #000000a0; pointer-events: inherit; z-index: 101; display: flex; color: white; justify-content: center; align-items: center; font-size: 28px;`)
        document.body.append(finalizingOverlay)
        finalizingOverlay.innerHTML = `
        <div>
            No screenshots have been captured for video creation yet.
        </div>
        `
        setTimeout(() => {
            finalizingOverlay.remove()
            if (window.location.href == `${origin}/tutor-shot-list`) {
                window.location.reload()
            } else {
                window.open(`${origin}/tutor-shot-list`)
            }
              reRenderFloatingBar(data)
        }, 2000)
        reRenderFloatingBar(data)
    }
    else if (message.message == 'limitExceed') {
        finalizingOverlay = document.createElement('div')
        finalizingOverlay.setAttribute('class', 'tutor-shot-overlay')
        finalizingOverlay.setAttribute('style', `all: unset; position: fixed; top: 0px; bottom: 0px; left: 0px; right: 0px; background-color: #000000a0; pointer-events: inherit; z-index: 101; display: flex; color: white; justify-content: center; align-items: center; font-size: 28px;`)
        document.body.append(finalizingOverlay)
        finalizingOverlay.innerHTML = `
        <div>
         Video creation limit reached.
         Upgrade to continue or contact support. 
        </div>
        `
        setTimeout(() => {
            finalizingOverlay.remove()        
              reRenderFloatingBar(data)
        }, 2000)
        reRenderFloatingBar(data)
    }
    else if (message.message == 'generatingVideo') {
        finalizingOverlay = document.createElement('div')
        finalizingOverlay.setAttribute('class', 'tutor-shot-overlay')
        finalizingOverlay.setAttribute('style', `all: unset; position: fixed; top: 0px; bottom: 0px; left: 0px; right: 0px; background-color: #000000a0; pointer-events: inherit; z-index: 101; display: flex; color: white; justify-content: center; align-items: center; font-size: 28px;`)
        document.body.append(finalizingOverlay)
        finalizingOverlay.innerHTML = `
        <div>
            Your video is being saved.
        </div>
        `
        setTimeout(() => {
            finalizingOverlay.remove()
            if (window.location.href == `${origin}/tutor-shot-list`) {
                window.location.reload()
            } else {
                window.open(`${origin}/tutor-shot-list`)
            }
            reRenderFloatingBar(data)
        }, 2000)
        reRenderFloatingBar(data)

    }

});


async function startRecording() {
    try {
        await getCaptureData();
        if(imageNumber>=1){
        let { data } = await api.post('/tutor-shot', { title: "No Title" }, { headers: { userId: userDetails.uid } })
        if (data.success) {
            await chrome.runtime.sendMessage({ action: "startRecording", tutorShotId: data.tutorShot._id })
        }
    }
        else return
    } catch (err) {
        console.log('error while starting to record', err)
        inProgress = false
    }
}

async function pauseRecording() {
    await chrome.runtime.sendMessage({ action: "pauseRecording" })
}
async function resumeRecording() {
    await chrome.runtime.sendMessage({ action: "resumeRecording" })
}

async function stopRecording() {
    try {
        await chrome.runtime.sendMessage({ action: "stopRecording" })
    } catch (err) {
        console.log(err)
    }
}

async function restartRecording() {
    try {
        await chrome.runtime.sendMessage({ action: "restartRecording" })
    } catch (err) {
        console.log(err)
    }
}

function changeBarPosition() {
    let sidebarPosition = floatingBar.classList.contains('tutor-shot-right')
    if (sidebarPosition) {
        floatingBar.classList.add('tutor-shot-left')
        floatingBar.classList.remove('tutor-shot-right')
        btn.switch.style.transform = "rotate(180deg)"
    } else {
        btn.switch.style.transform = ""
        floatingBar.classList.remove('tutor-shot-left')
        floatingBar.classList.add('tutor-shot-right')
    }
}
